unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function DynRegClassCheckNotify(const AClass: TClass): Boolean;
  function DynRegClassListNotify(const AClass: TClass; var AParam): Boolean;
var
  Form1: TForm1;
  ModuleList: TList;

implementation

{$R *.dfm}

uses
  DynRegClasses;

function DynRegClassCheckNotify(const AClass: TClass): Boolean;
begin

  Result:= True;
  // If I care about current class I can do some work in here.
  // Also I can stop the whole process of registering classes if I set
  // Result:= False;

end;

function DynRegClassListNotify(const AClass: TClass; var AParam): Boolean;
begin

  Result:= True;
  TMemo(AParam).Lines.Add('Found a class: ' + AClass.ClassName);
  // I can do any work I want done with the classes which were dynamically registered.
  // I can stop the whole process of notifying me it I set
  // Result:= False; 

end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  ModuleList:= TList.Create;
  ModuleList.Clear;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin

  if OpenDialog1.Execute then begin
    try
      ModuleList.Add(Pointer(LoadPackage(OpenDialog1.FileName)));
      DynRegisterClasses(Cardinal(ModuleList.Last), DynRegClassCheckNotify);
    except
      on E: Exception do
        ShowMessage('Error found:' + #13#10 + E.ClassName + #13#10 + E.Message);
    end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin

  Memo1.Lines.Clear;
  GetDynRegClasses(DynRegClassListNotify, Memo1);

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I: Integer;
begin

  Memo1.Clear;
  if (ModuleList.Count > 0) then
    for I:= (ModuleList.Count-1) downto 0 do begin
      DynUnRegisterClasses(Cardinal(ModuleList[I]));
      ModuleList.Delete(I);
    end;

end;

end.
